import requests
import logging


def get_secret(secret_name, source):
    logging.debug(f'Retrieving secret "{secret_name}" from {source}')

    def get_secret_power_automate(secret_name):
        PA_SECRETS_URL = 'https://prod-40.westus.logic.azure.com:443/workflows/c0cb9c1724a7419390eec44d3029f1b3/triggers/manual/paths/invoke?api-version=2016-06-01&sp=%2Ftriggers%2Fmanual%2Frun&sv=1.0&sig=lJsp-D3DfQ25p6x_CW0z26seCRh3f-BXgrPt-w6H_mQ'
        logging.debug(f'Retrieving secret via Power Automate: {PA_SECRETS_URL}')
        r = requests.post(
            url=PA_SECRETS_URL,
            headers={'Content-Type': 'application/json'}, 
            json={'secretName': secret_name}
        )
        secret_value = r.json()['secretvalue']
        logging.debug(f'Retrieved value: {secret_value}')
        return secret_value
    
    def get_secret_local(secret_name, file_path):
        logging.debug(f'Retrieving secret from local file')
        value = ''
        lines = []
        with open(file_path, 'r') as f:
            lines = f.readlines()
        for line in lines:
            name, value = line.split('=')
            name = name.strip()
            value = value.strip()
            if name == secret_name:
                logging.debug(f'Retrieved value: {value}')
                return value

    if source == 'azure':   return get_secret_power_automate(secret_name)
    else:                   return get_secret_local(secret_name, source)
